#include "excelengine.h"
#include "qt_windows.h"

#include <windows.h>
ExcelEngine::ExcelEngine()
{
    pExcel     = NULL;
    pWorkbooks = NULL;
    pWorkbook  = NULL;
    pWorksheet = NULL;

    sXlsFile     = "";
    nRowCount    = 0;
    nColumnCount = 0;
    nStartRow    = 0;
    nStartColumn = 0;

    bIsOpen     = false;
    bIsValid    = false;
    bIsANewFile = false;
    bIsSaveAlready = false;

    HRESULT r = OleInitialize(0);
    if (r != S_OK && r != S_FALSE)
    {
        qDebug("Qt: Could not initialize OLE (error %x)", (unsigned int)r);
    }
}

ExcelEngine::ExcelEngine(QString xlsFile)
{
    pExcel     = NULL;
    pWorkbooks = NULL;
    pWorkbook  = NULL;
    pWorksheet = NULL;

    sXlsFile     = xlsFile;
    nRowCount    = 0;
    nColumnCount = 0;
    nStartRow    = 0;
    nStartColumn = 0;

    bIsOpen     = false;
    bIsValid    = false;
    bIsANewFile = false;
    bIsSaveAlready = false;

    HRESULT r = OleInitialize(0);
    if (r != S_OK && r != S_FALSE)
    {
        qDebug("Qt: Could not initialize OLE (error %x)", (unsigned int)r);
    }
}

ExcelEngine::~ExcelEngine()
{
    if ( bIsOpen )
    {
        //ǰȱݣȻرworkbook
        Close();
    }
    OleUninitialize();
}

/**
  *@brief sXlsFileָexcel
  *@return true : 򿪳ɹ
  *        false: ʧ
  */
bool ExcelEngine::Open(UINT nSheet, bool visible)
{

    if ( bIsOpen )
    {
        //return bIsOpen;
        Close();
    }

    nCurrSheet = nSheet;
    bIsVisible = visible;

    if ( NULL == pExcel )
    {
        pExcel = new QAxObject("Excel.Application");
        if ( pExcel )
        {
            bIsValid = true;
        }
        else
        {
            bIsValid = false;
            bIsOpen  = false;
            return bIsOpen;
        }

        pExcel->dynamicCall("SetVisible(bool)", bIsVisible);
    }

    if ( !bIsValid )
    {
        bIsOpen  = false;
        return bIsOpen;
    }

    if ( sXlsFile.isEmpty() )
    {
        bIsOpen  = false;
        return bIsOpen;
    }

    /*ָļڣҪ½һ*/
    QFile f(sXlsFile);
    if (!f.exists())
    {
        bIsANewFile = true;
    }
    else
    {
        bIsANewFile = false;
    }

    if (!bIsANewFile)
    {
        pWorkbooks = pExcel->querySubObject("WorkBooks"); //ȡ
        pWorkbook = pWorkbooks->querySubObject("Open(QString, QVariant)",sXlsFile,QVariant(0)); //xlsӦĹ
    }
    else
    {
        pWorkbooks = pExcel->querySubObject("WorkBooks");     //ȡ
        pWorkbooks->dynamicCall("Add");                       //һµĹ
        pWorkbook  = pExcel->querySubObject("ActiveWorkBook"); //½һxls
    }

    pWorksheet = pWorkbook->querySubObject("WorkSheets(int)", nCurrSheet);//򿪵һsheet

    //Ѵ򿪣ʼȡӦ
    QAxObject *usedrange = pWorksheet->querySubObject("UsedRange");//ȡsheetʹ÷Χ
    QAxObject *rows = usedrange->querySubObject("Rows");
    QAxObject *columns = usedrange->querySubObject("Columns");

    //ΪexcelԴݶһǴ0,0ʼҪȡ±
    nStartRow    = usedrange->property("Row").toInt();    //һеʼλ
    nStartColumn = usedrange->property("Column").toInt(); //һеʼλ

    nRowCount    = rows->property("Count").toInt();       //ȡ
    nColumnCount = columns->property("Count").toInt();    //ȡ

    bIsOpen  = true;
    return bIsOpen;
}

/**
  *@brief Open()غ
  */
bool ExcelEngine::Open(QString xlsFile, UINT nSheet, bool visible)
{
    sXlsFile = xlsFile;
    nCurrSheet = nSheet;
    bIsVisible = visible;

    return Open(nCurrSheet,bIsVisible);
}

/**
  *@brief ݣдļ
  */
void ExcelEngine::Save()
{
    if ( pWorkbook )
    {
        if (bIsSaveAlready)
        {
            return ;
        }

        if (!bIsANewFile)
        {
            pWorkbook->dynamicCall("Save()");
        }
        else /*ĵ½ģʹΪCOMӿ*/
        {
            pWorkbook->dynamicCall("SaveAs (const QString&,int,const QString&,const QString&,bool,bool)",
                      sXlsFile,56,QString(""),QString(""),false,false);

        }

        bIsSaveAlready = true;
    }
}

/**
  *@brief رǰȱݣȻرյǰExcel COM󣬲ͷڴ
  */
void ExcelEngine::Close()
{
    //رǰȱ
    Save();

    if ( pExcel && pWorkbook )
    {
        pWorkbook->dynamicCall("Close(bool)", true);
        pExcel->dynamicCall("Quit()");

        delete pExcel;
        pExcel = NULL;

        bIsOpen     = false;
        bIsValid    = false;
        bIsANewFile = false;
        bIsSaveAlready = true;
    }
}

/**
  *@brief tableWidgetеݱ浽excel
  *@param tableWidget : ָGUIеtablewidgetָ
  *@return ɹ true : ɹ
  *                  false: ʧ
  */
bool ExcelEngine::SaveDataFrTable(QTableWidget *tableWidget)
{
    if ( NULL == tableWidget )
    {
        return false;
    }
    if ( !bIsOpen )
    {
        return false;
    }
    int tableR = tableWidget->rowCount();
    int tableC = tableWidget->columnCount();

    //ȡͷдһ
    for (int i=0; i<tableC; i++)
    {
        if ( tableWidget->horizontalHeaderItem(i) != NULL )
        {
            this->SetCellData(1,i+1,tableWidget->horizontalHeaderItem(i)->text());
        }
    }

    //д
    for (int i=0; i<tableR; i++)
    {
        for (int j=0; j<tableC; j++)
        {
            if ( tableWidget->item(i,j) != NULL )
            {
                this->SetCellData(i+2,j+1,tableWidget->item(i,j)->text());
            }
        }
    }

    //
    Save();

    return true;
}

/**
  *@brief ָxlsļаݵ뵽tableWidget
  *@param tableWidget : ִҪ뵽tablewidgetָ
  *@return ɹ true : ɹ
  *                   false: ʧ
  */
bool ExcelEngine::ReadDataToTable(QTableWidget *tableWidget)
{
    if ( NULL == tableWidget )
    {
        return false;
    }

    //Ȱtable
    int tableColumn = tableWidget->columnCount();
    tableWidget->clear();
    for (int n=0; n<tableColumn; n++)
    {
        tableWidget->removeColumn(0);
    }

    int rowcnt    = nStartRow + nRowCount;
    int columncnt = nStartColumn + nColumnCount;

    //ȡexcelеĵһΪͷ
    QStringList headerList;
    for (int n = nStartColumn; n<columncnt; n++ )
    {
        QAxObject * cell = pWorksheet->querySubObject("Cells(int,int)",nStartRow, n);
        if ( cell )
        {
            headerList<<cell->dynamicCall("Value2()").toString();
        }
    }

    //´ͷ
    tableWidget->setColumnCount(nColumnCount);
    tableWidget->setHorizontalHeaderLabels(headerList);


    //
    for (int i = nStartRow+1, r = 0; i < rowcnt; i++, r++ )  //
    {
        tableWidget->insertRow(r); //
        for (int j = nStartColumn, c = 0; j < columncnt; j++, c++ )  //
        {
            QAxObject * cell = pWorksheet->querySubObject("Cells(int,int)", i, j );//ȡԪ

            //r
            if ( cell )
            {
                tableWidget->setItem(r,c,new QTableWidgetItem(cell->dynamicCall("Value2()").toString()));
            }
        }
    }

    return true;
}

/**
  *@brief ȡָԪ
  *@param row : Ԫк
  *@param column : Ԫк
  *@return [row,column]ԪӦ
  */
QVariant ExcelEngine::GetCellData(UINT row, UINT column)
{
    QVariant data;

    QAxObject *cell = pWorksheet->querySubObject("Cells(int,int)",row,column);//ȡԪ
    if ( cell )
    {
        data = cell->dynamicCall("Value2()");
    }

    return data;
}

/**
  *@brief ޸ָԪ
  *@param row : Ԫк
  *@param column : Ԫָк
  *@param data : ԪҪ޸Ϊ
  *@return ޸Ƿɹ true : ɹ
  *                   false: ʧ
  */
bool ExcelEngine::SetCellData(UINT row, UINT column, QVariant data)
{
    bool op = false;

    QAxObject *cell = pWorksheet->querySubObject("Cells(int,int)",row,column);//ȡԪ
    if ( cell )
    {
        QString strData = data.toString(); //excel Ȼַֻܲͣ޷
        cell->dynamicCall("SetValue(const QVariant&)",strData); //޸ĵԪ
        op = true;
    }
    else
    {
        op = false;
    }

    return op;
}

/**
  *@brief ճ֮
  */
void ExcelEngine::Clear()
{
    sXlsFile     = "";
    nRowCount    = 0;
    nColumnCount = 0;
    nStartRow    = 0;
    nStartColumn = 0;
}

/**
  *@brief жexcelǷѱ
  *@return true : Ѵ
  *        false: δ
  */
bool ExcelEngine::IsOpen()
{
    return bIsOpen;
}

/**
  *@brief жexcel COMǷóɹexcelǷ
  *@return true : 
  *        false: 
  */
bool ExcelEngine::IsValid()
{
    return bIsValid;
}

/**
  *@brief ȡexcel
  */
UINT ExcelEngine::GetRowCount()const
{
    return nRowCount;
}

/**
  *@brief ȡexcel
  */
UINT ExcelEngine::GetColumnCount()const
{
    return nColumnCount;
}
