#ifndef EXCELENGINE_H
#define EXCELENGINE_H

#include <QObject>
#include <QFile>
#include <QString>
#include <QStringList>
#include <QVariant>
#include <QAxBase>
#include <QAxObject>

#include <QTableWidget>
#include <QTableView>
#include <QTableWidgetItem>
#include <QDebug>

typedef unsigned int UINT;

/**
  *@brief һQtдexcelװ࣬ͬʱڰexcelе
  *ʾϣ߰ѽϵдexcelУͬGUIнϵ£
  *Qt tableWidget <--> ExcelEngine <--> xls file.
  *
  *@note ExcelEngineֻ/дݣм
  *@author yaoboyuan 254200341@qq.com
  *@date 2012-4-12
  */
class ExcelEngine : protected QObject
{
public:
    ExcelEngine();
    ExcelEngine(QString xlsFile);
    ~ExcelEngine();

public:
    bool Open(UINT nSheet = 1, bool visible = false);//xlsļ
    bool Open(QString xlsFile, UINT nSheet = 1, bool visible = false);
    void Save();                //xls
    void Close();               //رxls

    bool SaveDataFrTable(QTableWidget *tableWidget); //ݵxls
    bool ReadDataToTable(QTableWidget *tableWidget); //xlsȡݵui

    QVariant GetCellData(UINT row, UINT column);                //ȡָԪ
    bool     SetCellData(UINT row, UINT column, QVariant data); //޸ָԪ

    UINT GetRowCount()const;
    UINT GetColumnCount()const;

    bool IsOpen();
    bool IsValid();

protected:
    void Clear();

private:
    QAxObject *pExcel;      //ָexcelӦó
    QAxObject *pWorkbooks;  //ָ,excelкܶ๤
    QAxObject *pWorkbook;   //ָsXlsFileӦĹ
    QAxObject *pWorksheet;  //ָеĳsheet

    QString   sXlsFile;     //xlsļ·
    UINT      nCurrSheet;   //ǰ򿪵ĵڼsheet
    bool      bIsVisible;   //excelǷɼ
    int       nRowCount;    //
    int       nColumnCount; //
    int       nStartRow;    //ʼݵ±ֵ
    int       nStartColumn; //ʼݵ±ֵ

    bool      bIsOpen;      //ǷѴ
    bool      bIsValid;     //ǷЧ
    bool      bIsANewFile;  //Ƿһ½xlsļִ򿪵excelѴļб½
    bool      bIsSaveAlready;//ֹظ

};

#endif // EXCELENGINE_H
